package tutorial.jsf.ajax.component;

import javax.faces.component.UIComponentBase;
import javax.faces.context.FacesContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import tutorial.jsf.ajax.AjaxInterface;
import tutorial.jsf.ajax.AjaxRendererInterface;

/**
 * <b>Created:</b> Nov 3, 2007<br>
 * <b>Title:</b> AjaxComponent<br>
 * <b>Description:</b><br>
 * @author Matt Tyson
 * <p>
 * @todo add class overview here
 */

public class AjaxComponent extends UIComponentBase implements AjaxInterface {
	private static final transient Log log = LogFactory.getLog(tutorial.jsf.ajax.component.AjaxComponent.class);
	
	public static final String DEFAULT_RENDERER_TYPE = "tutorial.jsf.ajax.component.AjaxComponentRenderer";
	public static final String COMPONENT_FAMILY = "tutorial.jsf.ajax.component.AjaxComponent";
	public static final String COMPONENT_TYPE = "tutorial.jsf.ajax.component.AjaxComponent"; // Used by Tag Handler
	
	/**default empty constructor*/
	public AjaxComponent() {
		this.setRendererType(AjaxComponent.DEFAULT_RENDERER_TYPE);
	}

	@Override
	public String getFamily() {
		return COMPONENT_FAMILY;
	} 
	
	/**
	 * This method is executed by the Ajax listener when an Ajax call for this component is detected.
	 */
	public void handleAjaxRequest(FacesContext context){
		// Delegate to the Renderer
		AjaxRendererInterface renderer = (AjaxRendererInterface)this.getRenderer(context);
		renderer.handleAjaxRequest(context, this);
	}
}
