AjaxComponent = function() {}

AjaxComponent.server = "";
AjaxComponent.inputField = "";
AjaxComponent.messageDiv = null; // The div (domNode) the holds the message
AjaxComponent.clientId = "";

/**
 * Gets the various parts of the component and sets up required event handling.
 */
AjaxComponent.loadComponent = function(){
	// Get the Server
	var serverField = document.getElementById("tutorial.jsf.ajax.component.SERVER");
	AjaxComponent.server = serverField.value; // Save the server for use in ajax call
	
	// Get the output message div
	var msgDiv = document.getElementById("tutorial.jsf.ajax.component.MESSAGE_DIV");
	AjaxComponent.messageDiv = msgDiv; // This is the actual domNode
	
	// Get the output message div
	var clientId = document.getElementById("tutorial.jsf.ajax.component.CLIENT_ID");
	AjaxComponent.clientId = clientId.value;
	
	// Get the button
	var button = document.getElementById("tutorial.jsf.ajax.component.BUTTON");
	// Use dojo to add an event handler -- like onClick="..." but handles cross browser issues
	dojo.event.connect(button, "onclick", AjaxComponent, "onButtonClick");
}

/**
 * onClick event handler.
 */
AjaxComponent.onButtonClick = function(evt){
	// Get the input text field
	var input = document.getElementById("tutorial.jsf.ajax.component.INPUT");
	AjaxComponent.inputField = input.value;
	
	// Build the request params
	var params = {
		"tutorial.jsf.ajax.AJAX_REQUEST" : "true",
		"tutorial.jsf.ajax.component.INPUT" : AjaxComponent.inputField,
		"tutorial.jsf.ajax.AJAX_CLIENT_ID" : AjaxComponent.clientId
	};
	// Send ajax request
	dojo.io.bind({
				url: AjaxComponent.server,
				method: "GET",
				load: function(type, data, evt){ 
					AjaxComponent.onAjaxResponse(data);
				},
				mimetype: "text/xml",
				content: params
			});
}

/**
 * Handles the response back from the server after an Ajax call is made.
 */
AjaxComponent.onAjaxResponse = function(responseXml){	
    var status = responseXml.getElementsByTagName("status")[0].childNodes[0].nodeValue;
    var msg = responseXml.getElementsByTagName("message")[0].childNodes[0].nodeValue;
    
    var style = "";
    if (status != "OK"){
    	style = "color: red;"; 
    }
    
    var msgNode = document.createTextNode(msg);
    
    var para = document.createElement("p");
    para.setAttribute("style", style);
    para.appendChild(msgNode);
    
	AjaxComponent.messageDiv.appendChild(para);
}